*+
*+
*+    Source Module => D:\SRC\CRLF_FIX\CRLF_FIX.PRG
*+
*+    Released to Public Domain by Phil Barnett
*+
*+    Functions: Function crlf_fix()
*+
*+    Reformatted by Click! 2.03 on Aug-8-1999 at  2:13 am
*+
*+

*+
*+
*+    Function crlf_fix()
*+
*+
*+
function crlf_fix( param1, param2 )

local nChoice

if param1 == nil .or. param2 == nil
   ? 'Usage:', 'CRLF_FIX <Input Name> <Output Name>'
   ?
   quit
endif

if !file( param1 )
   ? 'Input Name ' + param1 + ' does not exist.'
   ?
   quit
endif

clear screen

if file( param2 )
   if !verify( 'Output Name ' + param2 + ' already exists.', .t., 'Overwrite', 'Abort' )
      quit
   endif
endif

nChoice := mverify( 'Convert Style', 3, { 'To UNIX', 'From UNIX', 'Abort' } )

do case
case nChoice == 1
   if verify( { 'Converting DOS to UNIX on:', '', 'Input File ' + param1, '', 'Output File ' + param2 }, .t., 'Convert', 'Abort' )
      filetran( param1, param2, chr( 13 ) + chr( 10 ), chr( 13 ) )
   endif
case nChoice == 2
   if verify( { 'Converting UNIX to DOS on:', '', 'Input File ' + param1, '', 'Output File ' + param2 }, .t., 'Convert', 'Abort' )
      filetran( param1, param2, chr( 13 ), chr( 13 ) + chr( 10 ) )
   endif
endcase

return NIL

*+ EOF: CRLF_FIX.PRG
