*+
*+
*+    Source Module => D:\SRC\CRLF_FIX\PRB_POP.PRG
*+
*+    Released to Public Domain by Phil Barnett
*+
*+    Functions: Function pop_get()
*+               Procedure pop_set()
*+               Function POP_MSG()
*+               Procedure CLR_MSG()
*+               Procedure ATTENTION()
*+               Procedure CNT()
*+               Function c()
*+               Function Amaxstrlen()
*+               Function VERIFY()
*+               Function ASK_FOR()
*+               Static Procedure cls()
*+               Function FULLDATE()
*+               Function RJ()
*+               Function LJ()
*+               Function MVERIFY()
*+               Function alert()
*+
*+    Reformatted by Click! 2.03 on Aug-8-1999 at  2:13 am
*+
*+

#include "COMMON.CH"
#include "BOX.CH"
#include "SET.CH"
#include "INKEY.CH"
#include "COLOR.CH"

static THISSCRN
static TL
static BOXHIGH

*+
*+
*+    Function pop_get()
*+
*+
*+
function pop_get()

return { THISSCRN, TL, BOXHIGH }

*+
*+
*+    Procedure pop_set()
*+
*+
*+
procedure pop_set( aPopData )

THISSCRN := aPopData[ 1 ]
TL       := aPopData[ 2 ]
BOXHIGH  := aPopData[ 3 ]

return

*+
*+
*+    Function POP_MSG()
*+
*+    Called from ( prb_pop.prg  )   1 - function verify()
*+                                   1 - function ask_for()
*+
*+
*+
function POP_MSG( cText, lWait4Key, cColorBord, cColorMain )

local MAXLEN
local x
local nArrLen
local CROW
local CCOL
local LC

default lWait4Key to .t.

default cColorBord to 'B+/W'
default cColorMain to 'N/W,W+/B'

if !isarray( cText )
   cText := { cText }
endif

nArrLen := len( cText )

TL := ( ( maxrow() / 2 ) - ( int( nArrLen / 2 ) + 2 ) ) + 1

MAXLEN := min( maxcol() - 4, max( Amaxstrlen( cText ), 25 ) + 6 )

BOXHIGH  := nArrLen + 2
THISSCRN := savescreen( TL - 2, 0, BOXHIGH + TL + 1, maxcol() )
CROW     := row()
CCOL     := col()

LC := int( ( maxcol() - MAXLEN ) / 2 )

dispbox( TL - 1, LC, BOXHIGH + TL, LC + MAXLEN - 1, B_DOUBLE_SINGLE + ' ', cColorBord )

for x := 1 to nArrLen
   CNT( cText[ x ], TL + x, cColorMain )
next

if lWait4Key
   ATTENTION( 'Press any key to continue', BOXHIGH + TL )
   allkey( 0 )
   restscreen( TL - 2, 0, BOXHIGH + TL + 1, 79, THISSCRN )
   THISSCRN := ''
   devpos( CROW, CCOL )
endif

return { TL, lc }

*+
*+
*+    Procedure CLR_MSG()
*+
*+    Called from ( prb_pop.prg  )   1 - function verify()
*+                                   1 - function ask_for()
*+
*+
*+
procedure CLR_MSG()

restscreen( TL - 2, 0, BOXHIGH + TL + 1, 79, THISSCRN )

THISSCRN := ''

return

*+
*+
*+    Procedure ATTENTION()
*+
*+    Called from ( prb_pop.prg  )   1 - function pop_msg()
*+
*+
*+
procedure ATTENTION( cString, nLineNum, cColor )

default nLineNum to 24
default cColor to 'GR+/R'

cString := '  ' + alltrim( cString ) + '  '

devpos( nLineNum, c( cString ) )

devout( cString, cColor )

return

*+
*+
*+    Procedure CNT()
*+
*+    Called from ( prb_pop.prg  )   1 - function pop_msg()
*+
*+
*+
procedure CNT( cString, nLineNum, cColorMain )

devpos( nLineNum, c( cString ) )

devout( cString, cColorMain )

return

*+
*+
*+    Function c()
*+
*+    Called from ( prb_pop.prg  )   1 - procedure attention()
*+                                   1 - procedure cnt()
*+                                   2 - function ask_for()
*+                                   6 - function mverify()
*+
*+
*+
function c( cString )

return max( ( maxcol() / 2 ) - int( len( cString ) / 2 ), 0 )

*+
*+
*+    Function Amaxstrlen()
*+
*+    Called from ( prb_pop.prg  )   1 - function pop_msg()
*+                                   1 - function mverify()
*+
*+
*+
function Amaxstrlen( ANARRAY )

local nArrLen
local THISLEN
local max     := 0
local x

if isarray( ANARRAY )

   nArrLen := len( ANARRAY )

   for x := 1 to nArrLen
      THISLEN := len( ANARRAY[ X ] )
      if THISLEN > max
         max := THISLEN
      endif
   next

endif

return max

*+
*+
*+    Function VERIFY()
*+
*+    Called from ( crlf_fix.prg )   3 - function crlf_fix()
*+
*+
*+
function VERIFY( cText, LNORMANS, YES_PRMPT, NO_PRMPT, cColorBord, cColorMain )

local INCOLOR
local VERI

default cColorBord to 'W+/R'
default cColorMain to 'W+/R,W+/B'

LNORMANS  := iif( islogic( LNORMANS ), LNORMANS, .t. )
YES_PRMPT := iif( YES_PRMPT == NIL, ' YES ', ' ' + alltrim( YES_PRMPT ) + ' ' )
NO_PRMPT  := iif( NO_PRMPT == NIL, ' NO ', ' ' + alltrim( NO_PRMPT ) + ' ' )

if !isarray( cText )
   cText := { cText }
endif

aadd( cText, '' )
aadd( cText, '' )

POP_MSG( cText, .f., cColorBord, cColorMain )

VERI := iif( LNORMANS, 1, 2 )

INCOLOR := setcolor( cColorMain )
@ TL - 2 + BOXHIGH, 33 - ( len( YES_PRMPT ) / 2 ) prompt YES_PRMPT
@ TL - 2 + BOXHIGH, 46 - ( len( NO_PRMPT ) / 2 ) prompt NO_PRMPT

menu to VERI

clr_msg()

setcolor( INCOLOR )

return ( VERI == 1 )

*+
*+
*+    Function ASK_FOR()
*+
*+
*+
function ASK_FOR( cText, Getvar, PICVAR, cColorBord, cColorMain )

local GETLIST := {}

local INCURSOR := set( _SET_CURSOR )
local nArrLen
local VCNT
local RETVAL
local CROW     := row()
local CCOL     := col()

default cColorBord to 'W+/B'
default cColorMain to 'W+/B,W/N'

if !isarray( cText )
   cText := { cText }
endif

nArrLen := len( cText ) + 2

asize( cText, nArrLen )

do case
case ischaracter( Getvar )
   VCNT := c( Getvar )
case isdate( Getvar )
   VCNT := 35
case isnumber( Getvar )
   VCNT := c( PICVAR )
otherwise
   VCNT := maxcol() / 2
endcase

cText[ nArrLen - 1 ] := ''
cText[ nArrLen ]     := space( ( ( maxcol() / 2 ) - VCNT ) * 2 )

POP_MSG( cText, .f., cColorBord, cColorMain )

if isdate( Getvar )
   @ TL + BOXHIGH - 2, VCNT get Getvar color( cColorMain )        
else
   @ TL + BOXHIGH - 2, VCNT get Getvar color( cColorMain ) picture PICVAR       
endif

set cursor ( .t. )
read
set( _SET_CURSOR, INCURSOR )

clr_msg()

RETVAL := Getvar

if ischaracter( Getvar )
   Getvar := alltrim( Getvar )
endif

devpos( CROW, CCOL )

return RETVAL

*+
*+
*+    Static Procedure cls()
*+
*+
*+
static procedure cls( NEWCOLOR, BKGCHR )

default NEWCOLOR to 'GB+/N,R/W,,,W+/N'
default BKGCHR to 177

setcolor( NEWCOLOR )

dispbox( 0, 0, maxrow(), maxcol(), replicate( chr( BKGCHR ), 9 ) )

return

*+
*+
*+    Function FULLDATE()
*+
*+
*+
function FULLDATE( ANYDATE )

default ANYDATE to date()

return cmonth( ANYDATE ) + ' ' + ;
               ltrim( str( day( ANYDATE ), 2 ) ) + ', ' + ;
               str( year( ANYDATE ), 4 )

*+
*+
*+    Function RJ()
*+
*+
*+
function RJ( cString )

return padl( alltrim( cString ), len( cString ) )

*+
*+
*+    Function LJ()
*+
*+
*+
function LJ( cString )

return pad( alltrim( cString ), len( cString ) )

*+
*+
*+    Function MVERIFY()
*+
*+    Called from ( crlf_fix.prg )   1 - function crlf_fix()
*+                ( prb_pop.prg  )   1 - function alert()
*+
*+
*+
function MVERIFY( aMessage, nResult, aPrompts, xColorArray, ;
                  ccColorBord, ccColorMain, nTopLine )

local aPrompt     := {}
local nBoxHigh
local nMaxLen
local x
local nArrayLen
local aColorArray := {}
local nPrompts
local P_L
local PL1
local PL2
local PRL1
local PRL2
local PRLN1
local PRLN2
local aNewPrompt  := {}
local aButtonSeek := {}
local LC
local nKey
local nPointer

putscreen()

default aPrompts to { 'YES', 'NO' }

nPrompts := len( aPrompts )

asize( aNewPrompt, nPrompts )
for x := 1 to nPrompts
   aNewPrompt[ x ] := ' ' + alltrim( aPrompts[ x ] ) + ' '
next

aButtonSeek := aclone( aPrompts )
for x := 1 to nPrompts
   aButtonSeek[ x ] := upper( left( aButtonSeek[ x ], 1 ) )
next

if !isarray( aMessage )
   aMessage := { aMessage }
endif

nResult := iif( isnumber( nResult ), nResult, 1 )

default ccColorBord to 'B+/W'
default ccColorMain to 'N/W,W+/B'

nArrayLen := len( aMessage )

if valtype( xColorArray ) == 'A'
   aColorArray := aclone( xColorArray )
else
   aColorArray := array( nArrayLen )
   afill( aColorArray, ccColorMain )
endif

P_L := iif( nPrompts > 3, 2, 0 )

default nTopLine to 11 - ( ( nArrayLen / 2 ) + ( P_L / 2 ) )

nMaxLen := min( amaxstrlen( aMessage ), 25 )

PRLN1 := 0
PRLN2 := 0

if nPrompts == 1
   PRLN1 := len( aNewPrompt[ 1 ] )
endif
if nPrompts == 2 .or. nPrompts == 4
   PRLN1 := len( aNewPrompt[ 1 ] + aNewPrompt[ 2 ] ) + 6
endif
if nPrompts == 3 .or. nPrompts == 5 .or. nPrompts == 6
   PRLN1 := len( aNewPrompt[ 1 ] + aNewPrompt[ 2 ] + aNewPrompt[ 3 ] ) + 12
endif
if nPrompts == 4 .or. nPrompts == 5
   PRLN2 := len( aNewPrompt[ nPrompts - 1 ] + aNewPrompt[ nPrompts ] ) + 6
endif
if nPrompts == 6
   PRLN2 := len( aNewPrompt[ 4 ] + aNewPrompt[ 5 ] + aNewPrompt[ 6 ] ) + 12
endif

nMaxLen := max( nMaxLen, PRLN1 )
nMaxLen := max( nMaxLen, PRLN2 ) + 6
nMaxLen := min( 76, nMaxLen )

nBoxHigh := 3 + nArrayLen + P_L

LC := int( ( maxcol() - nMaxLen ) / 2 )
dispbox( nTopLine - 1, LC, nBoxHigh + nTopLine, LC + nMaxLen - 1, B_DOUBLE_SINGLE + ' ', ccColorBord )

for x := 1 to nArrayLen
   @ nTopLine + x, c( aMessage[ x ] ) say aMessage[ x ] color( aColorArray[ x ] )        
next

if P_L == 0
   PL1 := ( nTopLine + nBoxHigh ) - 1
else
   PL1 := ( nTopLine + nBoxHigh ) - 3
   PL2 := PL1 + 2
endif

aPrompt := {}

if nPrompts == 1
   aadd( aPrompt, { PL1, c( aNewPrompt[ 1 ] ), aNewPrompt[ 1 ] } )
endif
if nPrompts == 2 .or. nPrompts == 4
   PRL1 := c( aNewPrompt[ 1 ] + aNewPrompt[ 2 ] ) - 3
   aadd( aPrompt, { PL1, PRL1, aNewPrompt[ 1 ] } )
   aadd( aPrompt, { PL1, PRL1 + 6 + len( aNewPrompt[ 1 ] ), aNewPrompt[ 2 ] } )
endif
if nPrompts == 3 .or. nPrompts == 5 .or. nPrompts == 6
   PRL1 := c( aNewPrompt[ 1 ] + aNewPrompt[ 2 ] + aNewPrompt[ 3 ] ) - 6
   aadd( aPrompt, { PL1, PRL1, aNewPrompt[ 1 ] } )
   aadd( aPrompt, { PL1, PRL1 + 6 + len( aNewPrompt[ 1 ] ), aNewPrompt[ 2 ] } )
   aadd( aPrompt, { PL1, PRL1 + 12 + len( aNewPrompt[ 1 ] + aNewPrompt[ 2 ] ), aNewPrompt[ 3 ] } )
endif
if nPrompts == 4 .or. nPrompts == 5
   PRL2 := c( aNewPrompt[ nPrompts - 1 ] + aNewPrompt[ nPrompts ] ) - 3
   aadd( aPrompt, { PL2, PRL2, aNewPrompt[ nPrompts - 1 ] } )
   aadd( aPrompt, { PL2, PRL2 + 6 + len( aNewPrompt[ nPrompts - 1 ] ), aNewPrompt[ nPrompts ] } )
endif
if nPrompts == 6
   PRL2 := c( aNewPrompt[ 4 ] + aNewPrompt[ 5 ] + aNewPrompt[ 6 ] ) - 6
   aadd( aPrompt, { PL2, PRL2, aNewPrompt[ 4 ] } )
   aadd( aPrompt, { PL2, PRL2 + 6 + len( aNewPrompt[ 4 ] ), aNewPrompt[ 5 ] } )
   aadd( aPrompt, { PL2, PRL2 + 12 + len( aNewPrompt[ 4 ] + aNewPrompt[ 5 ] ), aNewPrompt[ 6 ] } )
endif

setcolor( ccColorMain )

do while .t.

   for x := 1 to nPrompts
      colorselect( iif( x == nResult, CLR_ENHANCED, CLR_STANDARD ) )
      @ aPrompt[ x, 1 ], aPrompt[ x, 2 ] say aPrompt[ x, 3 ]         
   next

   nKey := allkey( 0 )

   do case
   case nKey == K_UP .or. nKey == K_LEFT
      nResult --
      if nResult < 1
         nResult := nPrompts
      endif
   case nKey == K_DOWN .or. nKey == K_RIGHT
      nResult ++
      if nResult > nPrompts
         nResult := 1
      endif
   case nKey == K_ENTER
      exit
   case nKey == K_ESC
      nResult := 0
      exit
   otherwise
      // do a button seek here for this letter
      // if found, select it and exit
      nPointer := ascan( aButtonSeek, upper( chr( nKey ) ) )
      if nPointer > 0
         nResult := nPointer
         exit
      endif
   endcase

enddo

colorselect( 1 )

getscreen()

return nResult

*+
*+
*+    Function alert()
*+
*+
*+
function alert( cMessage, aChoices )

/*
  Replacement for Clipper's ALERT() Function
  ( up to six selector buttons )
*/

local nMsgLen
local x
local aMessage := {}

default aChoices to { 'OK' }

// load message array
nMsgLen := numtoken( cMessage, ';' )

asize( aMessage, nMsgLen )
for x := 1 to nMsgLen
   aMessage[ x ] := token( cMessage, ';', x )
next

return mverify( aMessage, 1, aChoices, 'W+/R', 'W+/R', 'W+/R,W+/B' )

*+ EOF: PRB_POP.PRG
