*+
*+
*+    Source Module => D:\SRC\CRLF_FIX\PRB_TRAN.PRG
*+
*+    Released to Public Domain by Phil Barnett
*+
*+    Functions: Function FILETRAN()
*+
*+    Reformatted by Click! 2.03 on Aug-8-1999 at  2:13 am
*+
*+

*+
*+
*+    Function FILETRAN()
*+
*+    Called from ( crlf_fix.prg )   2 - function crlf_fix()
*+
*+
*+
function FILETRAN( IN_FILE, OUT_FILE, LOOKFOR, REPWITH )

local Buffer
local BYTESREAD
local size      := 4096

local HANDLE_IN
local DATA_IN   := ''
local LOOKLEN   := len( DATA_IN ) - 1   // very important

local HANDLE_OUT
local DATA_OUT

HANDLE_IN := fopen( IN_FILE, 66 )       // open for shared read/write
if HANDLE_IN == - 1
   ? 'Error opening Input file.'
   return .f.
endif

HANDLE_OUT := fcreate( OUT_FILE, 0 )
if HANDLE_OUT == - 1
   fclose( HANDLE_IN )
   ? 'Error creating Output file.'
   return .f.
endif

BYTESREAD := size
do while BYTESREAD == size

   Buffer    := space( size )
   BYTESREAD := fread( HANDLE_IN, @Buffer, size )

   DATA_IN  += left( Buffer, BYTESREAD )
   DATA_OUT := strtran( DATA_IN, LOOKFOR, REPWITH )

   if BYTESREAD == size                 // there's more, keep looklen bytes for next loop
      DATA_IN  := right( DATA_OUT, LOOKLEN )
      DATA_OUT := left( DATA_OUT, BYTESREAD - LOOKLEN )
   endif

   fwrite( HANDLE_OUT, DATA_OUT )

enddo

fclose( HANDLE_IN )
fclose( HANDLE_OUT )

return .t.

*+ EOF: PRB_TRAN.PRG
